export default class Container {
    constructor() {
        this.services = new Map();
    }
    set(type, instance) {
        this.services.set(type, instance);
    }
    get(type) {
        const instance = this.services.get(type);
        if (!instance)
            throw new Error(`Service of type "${type.name}" not found.`);
        return instance;
    }
}
